
/*------------------------------------------------------------------
Got frequie running :) 20210526
20210527 toggle USB/LSB 

Modify for uBITX.7148

added delays on startup
And I2C scanning.
Need to add PTT input and filter switching.
Filter done!
Make filter switching on port pins, not the I2C extra.
swapped 4 and 0
Increased drive in frequie
It is not 1Mhz, but 11.052
Try to fix frequs that are not correct., by changing #defines to long ints for frequencies. No different :(
20210617 change to uint64_t and see if that fixes it. 
The display stuff is a bit sus now, sometimes an extra LS digit is shown
Swapped 13 and 26 to suit V3 board.

Added OLEDdisplay for metering.
Daniel updated Frequie to include calibrationHACK to bypass Si5351 init as it is not fitted to the PCB.
 HACK to ignore missing Si5351

 20220909 add #define for board versions, with displat of PCB version.
 20221212 Mod 20220909 for Codan 8727

 I canot get the band switching to work after startup!!!!
 FIXED??? added resetting the pinMode on the 4 outputs to the end of setup!
  BUT WHY?????
  20221216 fixed frequ not updating on band change. Moved freq setting from core0 to core1.
  20221219 put bacj I2C chip for band setting
  20221219R swapped clk0 and clk1
  20221220 Apply cal factor before init.
      add full range for testing when debug is defined.
      I had 3Khz erroe beacause tho offset was the wrong sideband. Now 1.647Mhz, not 1.65Mhz
  20221221 try to get the S meter running. It seems to only be called once?????? 
    Fixed. Moved to other code loop.
  20230103 Gave up on ADC band selection and used PCF8574A, active HIGH band select.
--------------------------------------------------------------------*/
//#define Version1PCB    // comment out if version 1 PCB not used.

#ifdef Version1PCB 
  #define NAME "VFO_Delux1"
#else
  #define NAME "VFO_Delux3"
#endif

#define DEBUG   // comment out to turn off the debug stuff.

#define VERSION "Codan_8727 20230103"
#define ID "by JF3HZB Daz DCP"


#include "driver/pcnt.h"
#include "display.h"
#include "graph.h"
#include "dial.h"
#include "frequie.h"
#include "wirei2c.h"
#include <Adafruit_GFX.h>             // https://github.com/adafruit/Adafruit-GFX-Library
#include <Adafruit_SSD1306.h>
#include "OLED.h"

#include "PCF8574.h"
PCF8574 PCF_01(0x23);                 // set PCH8574 address here.

Frequie<WireI2C<Wire, 21, 22, 100000>, SI5351_XTAL_25MHZ, SI5351_PLL_900MHZ, SI5351_DEVICE_ADDRESS, 3> frequie;/*

/*------Hard ware Configuration ---------------------
<<ESP32-DevKitC>>
pin No.  Connection
  17 :  Rotary Encoder A
  16 :  Rotary Encoder B

  22 :  si5351A SCL
  21 :  si5351A SDA

  18 :  SCK    / ST7735,SEPS525(128x160 display)  
  23 :  MOSI   / ST7735,SEPS525(128x160 display)
   5 :  CS     / ST7735,SEPS525(128x160 display)  
   2 :  DC(A0) / ST7735,SEPS525(128x160 display)
  15 :  RESET  / ST7735,SEPS525(128x160 display)


<<si5351A>>
CLK0 : sideband_offset
CLK1 : sigFreq+offset
CLK2 : not used
------------------------------------------------*/


/*----------------------------------------------------------
   Adaptive step control parameters
-----------------------------------------------------------*/
uint32_t vth=2;   	  // Velocity threshold for acceleration
float Racc=0.002;     // Rate of acceleration
float Rdec=1.0;       // Rate of deceleration
float MaxL=1500.0;	  // Max Step[Hz] = step_size + Racc*MaxL*MaxL

/*----------------------------------------------------------------------------------
    Control flags etc
-----------------------------------------------------------------------------------*/
uint8_t f_fchange;  // if frequency changed, set this flag to 1
uint8_t f_cchange;  // if Car frequency and/or "f_carON" changed, set this flag to 1
uint8_t f_dchange;  // if need to renew display, set this flag to 1

int last_sideband = 0;
int mute_audio    = 0;
int I_O_data      = 0;
byte updateFlag   =HIGH;

// synthesiser default settings on start up.
unsigned long frequency   =  0000000;          // 4 bytes required for frequency
unsigned long frequency0  =  1810000;          // 4 bytes required for frequency
unsigned long frequency1  =  3630000;          // 4 bytes required for frequency
unsigned long frequency2  =  7115000;          // 4 bytes required for frequency 
unsigned long frequency3  = 10100000;          // 4 bytes required for frequency
unsigned long frequency4  = 14100000;          // 4 bytes required for frequency
unsigned long frequency5  = 18068000;          // 4 bytes required for frequency
unsigned long frequency6  = 21000000;          // 4 bytes required for frequency
unsigned long frequency7  = 24890000;          // 4 bytes required for frequency
unsigned long frequency8  = 28000000;          // 4 bytes required for frequency
unsigned long frequency9  =  0000000;          // 4 bytes required for frequency
unsigned long frequency10 =  0000000;          // 4 bytes required for frequency
unsigned long genfrequency = 3630000;

#ifdef DEBUG
  #define MaxBand   5 // set to suit radio
#else
  #define MaxBand   4 // set to suit radio
#endif

unsigned long step_size = 10;           // default tuning increment (Hz) was 1000
unsigned long offset = 1647000;         // IF offset for clockgen when driving Kestral/Hawk RFDS Radio
static signed char ham_band_index = 2;  // start on 3.630000Mhz

unsigned long LSB =  1647000;           // carrier mixer for LSB
unsigned long USB =  1650000;           // carrier mixer for USB

unsigned long cal_factor = 10810;       //  eg. 16360 for my board, found from Si5351 calibrator sketch.

/*--------------------------------------------------------
   pin assign
----------------------------------------------------------*/

#define PULSE_INPUT_PIN 17 // Rotaty Encoder A
#define PULSE_CTRL_PIN  16 // Rotaty Encoder B

// these defined in the OLED file
//#define RecXmt_select    0     // receive transmit  select
//#define Xmt_Mode_select  4     // transmit disp select  power or swr
//#define Rec_Mode_select 12     // receive disp select  s-meter or vu meter
//#define Alt_Mode_select 32     // alternate display mode select

#define FetOut1   25
#define FetOut2   27

//#define s_meter_input 36       // S-Meter analog input
//#define vu_meter_input 39      // vu-Meter analog input  
//#define fwd_pwr_input 36       // forward power meter analog input
//#define rev_pwr_input 39       // reverse power meter analog input

// keypad matrix

#define Row0        33
#define Row1        34      // input only
#define Row2        35      // input only

#ifdef Version1PCB 
  #define tone_pin  13
  #define Col0      26
#else // version 3 PCB
  #define tone_pin  26 
  #define Col0      13
#endif

#define Col1        19
#define Col2        14

int repeat=LOW;             // autorepaet flag

byte key = 0;


//------------------------------------------------------------------------------

/*-----------------------------------------------------------------------------
 *       Global
-----------------------------------------------------------------------------*/
float L=0.0;
long afstp;
//uint64_t frq=init_freq;
unsigned long frq=3630000;  //init_freq;
int16_t RE_Count = 0;
uint8_t f_redraw; 
extern char f_rev;
extern uint32_t cl_BG;


/*--------------------------------------------------------------------------
        Timer ISR
---------------------------------------------------------------------------*/
hw_timer_t * timer = NULL;
void IRAM_ATTR onTimer(){}


void get_button()
{   key=0;
     digitalWrite(Col0,HIGH) ;
     delay(1);
   if (digitalRead(Row0) == HIGH) key=1;
   if (digitalRead(Row1) == HIGH) key=2;
   if (digitalRead(Row2) == HIGH) key=3; 
   digitalWrite(Col0,LOW);
   digitalWrite(Col1,HIGH);
        delay(1);
   if (digitalRead(Row0) == HIGH) key=4;
   if (digitalRead(Row1) == HIGH) key=5;
   if (digitalRead(Row2) == HIGH) key=6; 
   digitalWrite(Col1,LOW);
   digitalWrite(Col2,HIGH);
        delay(1);
   if (digitalRead(Row0) == HIGH) key=7;
   if (digitalRead(Row1) == HIGH) key=8;
   if (digitalRead(Row2) == HIGH) key=9; 
   digitalWrite(Col2,LOW);
}

 void read_buttons()
 {
    repeat=LOW;                 // autorepaet flag
    updateFlag=LOW;             // pre-lear the flag.
    get_button();
   if(key !=0)
   { updateFlag=HIGH;  
   }   
 } 

//-----------------------------------------------------------------------------------------------
void setup() {
//-----------------------------------------------------------------------------------------------
    genfrequency   =   3630000;
    ham_band_index = 1;
    last_sideband  = 0;
    
    char str[64];
    //--------- create tasks on core0 --------------------------------
    xTaskCreatePinnedToCore(task0, "Task0", 4096, NULL, 1, NULL, 0);
        
    //--------- Set up Interrupt Timer -------------------------------
    timer = timerBegin(0, 80, true); //use Timer0, div80 for 1us clock
    timerAttachInterrupt(timer, &onTimer, true);
    timerAlarmWrite(timer, 10000, true); // T=10000us
    timerAlarmEnable(timer); // Start Timer
    
    //--- Counter setup for Rotary Encoder ---------------------
    pcnt_config_t pcnt_config_A;// structure for A   
    pcnt_config_t pcnt_config_B;// structure for B
    //
    pcnt_config_A.pulse_gpio_num = PULSE_INPUT_PIN;
    pcnt_config_A.ctrl_gpio_num = PULSE_CTRL_PIN;
    pcnt_config_A.lctrl_mode = PCNT_MODE_REVERSE;
    pcnt_config_A.hctrl_mode = PCNT_MODE_KEEP;
    pcnt_config_A.channel = PCNT_CHANNEL_0;
    pcnt_config_A.unit = PCNT_UNIT_0;
    pcnt_config_A.pos_mode = PCNT_COUNT_INC;
    pcnt_config_A.neg_mode = PCNT_COUNT_DEC;
    pcnt_config_A.counter_h_lim = 10000;
    pcnt_config_A.counter_l_lim = -10000;
    //
    pcnt_config_B.pulse_gpio_num = PULSE_CTRL_PIN;
    pcnt_config_B.ctrl_gpio_num = PULSE_INPUT_PIN;
    pcnt_config_B.lctrl_mode = PCNT_MODE_KEEP;
    pcnt_config_B.hctrl_mode = PCNT_MODE_REVERSE;
    pcnt_config_B.channel = PCNT_CHANNEL_1;
    pcnt_config_B.unit = PCNT_UNIT_0;
    pcnt_config_B.pos_mode = PCNT_COUNT_INC;
    pcnt_config_B.neg_mode = PCNT_COUNT_DEC;
    pcnt_config_B.counter_h_lim = 10000;
    pcnt_config_B.counter_l_lim = -10000;
    //
    pcnt_unit_config(&pcnt_config_A);//Initialize A
    pcnt_unit_config(&pcnt_config_B);//Initialize B
    pcnt_counter_pause(PCNT_UNIT_0);
    pcnt_counter_clear(PCNT_UNIT_0);
    pcnt_counter_resume(PCNT_UNIT_0); //Start

  
    display_init();    
    GRAM_clr();                         // H,  V, colour
    sprintf(str,   ID   ); disp_str8 (str,50, 20, 0x00ffff);
    sprintf(str, VERSION); disp_str12(str, 0, 50, 0x00ffff);   
    sprintf(str,  NAME  ); disp_str16(str,20, 90, 0x00ffff);
    
    trans65k();
    f_redraw=1;

  Serial.begin(115200);
   PCF_01.write8(B00000000);


  delay(1000);
    
   pinMode(Row0,INPUT);
   pinMode(Row1,INPUT);
   pinMode(Row2,INPUT);
 
   pinMode(Col0,OUTPUT);
   pinMode(Col1,OUTPUT);
   pinMode(Col2,OUTPUT);
   digitalWrite(Col0,LOW);
   digitalWrite(Col1,LOW);
   digitalWrite(Col2,LOW);
    
   pinMode (tone_pin,OUTPUT);
   
   Serial.println("Scanning I2C....");

  frequie.scan_i2c_bus(Serial);

  Serial.println("Detecting device...");

  // HACK to ignore missing Si5351 for testing
#ifdef NoSi5351
  while(!frequie.detect()) {
    delay(1000);
    frequie.scan_i2c_bus(Serial);
  }
#endif

   Serial.println("Found :)");
   Serial.println("Starting Up");
   frequie.set_correction (cal_factor); // <<<<<<<this is found from Si5351 calibrator code.
   frequie.init();
   
    delay(1000); 
    
    init_Dial();
    GRAM_clr();
        
    f_fchange = 1;
    f_cchange = 1;
    f_dchange = 1;
    f_redraw=0;  

   frequie.set_clock_frequency(1, LSB);   // 1.650Mhz  (or 1.647Mhz)
   delay(100);
   frequie.enable_clock(0);
   
   frequie.set_clock_frequency(0, (genfrequency + offset)); // sig + offset
   delay(100);
   frequie.enable_clock(1);

  // analog input for outside  source
  pinMode(s_meter_input, INPUT);
  pinMode(vu_meter_input,INPUT);
  pinMode(fwd_pwr_input, INPUT);
  pinMode(rev_pwr_input, INPUT);

  pinMode(RecXmt_select,   INPUT_PULLUP);
  pinMode(Xmt_Mode_select, INPUT_PULLUP);
  pinMode(Rec_Mode_select, INPUT_PULLUP);
  pinMode(Alt_Mode_select, INPUT_PULLUP);

// init the OLED display
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);   // needed for SSD1306 display
  display.clearDisplay();      // clears display from any library info displayed
  // display.invertDisplay(1);     // option to invert display to black on white
  dsp_Mode = _S_MTR;            // start with default vu meter     
  dsp_S_Meter();   

}

//-----------------------------------------------------------------------------------------------
void loop() {    // (core1)
//-----------------------------------------------------------------------------------------------       
    char str[64];
   
    if(f_dchange==1){
        f_dchange=0;        
        //GRAM_clr();
        boxfill(0,0,Nx-1,Ny-1,cl_BG);     
        //Display Dial
        Dial(frq);

 // change box colour to indicate mute status
        if (mute_audio == 1)
    {   box(7,100,153,126, 0xa0a0a0); // whiteish
        box(6, 99,154,127, 0xa0a0a0);
    }
    else
    {   box(7,100,153,126, 0xffa0a0); // redish
        box(6, 99,154,127, 0xffa0a0);
    }
        
        //-------- Display Digital Frquency ---------------------------------------
        sprintf(str, "%3d.%03d,%02d",  frq/1000000, (frq/1000)%1000, (frq/10)%100 );
        disp_str16(str,17, 105, 0xffd080);  
//        sprintf(str, "MHz" ); // in place of the Mhz, put sideband.
        if  (last_sideband == 1)
    {   sprintf(str, "USB" );
    }
    else
    {   sprintf(str, "LSB" );
    }
        disp_str12(str,120, 106, 0xffd080);   // print the string.     
        if(f_redraw==0){
          trans65k();
          f_redraw=1;
        }            
    }
    
    read_buttons();   // get the button code. ) = no button.
    // button layout for V1 board......
    // 1  5   3
    // 4  8   6
    
    // button layout for V3 board......
    // 7 2 1   5    3
    //  9  4   8    6


if (key==1)          // upper sideband.
     {  frequie.set_clock_frequency(1, USB);      // 1.650Mhz
        last_sideband = 1;
        f_dchange=1;
     }
     
 if (key==2)
   {
   }
   
 if (key==3)        // band up.
   {   set_band(1);
   }

       
 if (key==4)
   {  frequie.set_clock_frequency(1, LSB);      // 1.647Mhz
      last_sideband = 0;
      f_dchange=1;
   }    

   
 if (key==5)        // toggle audio mute setting.
    { if(mute_audio == 0)
     { mute_audio = 1;}
    else {mute_audio = 0;}
    f_dchange=1;
    }

   
  if (key==6)       // band down.
    {  set_band(-1);
    }
    
  if (key==7)
   {
   }
   
    if (key==8)
   { 
   }
   
    if (key==9)
   {  
   }   

// debug info
#ifdef Debug
  if (key!=0)
    {Serial.println (key);}
#endif 
       
        while ((key!=0) &(repeat==LOW))  // wait untill button is released....
     {  get_button();} 
     
     if (updateFlag=HIGH)  {

  switch (ham_band_index) {       // limit to SSB part of bands
    case 0:     // 160 Meters
      frq = constrain(frq, 1800000, 1875000);
      frequency0 = frq;
      genfrequency=(frq);
      PCF_01.write8(B00000001); 
      break;
   
    case 1:     // 80 Meters
      frq = constrain(frq, 3500000, 3800000);
      frequency1 = frq;
      genfrequency=(frq);
      PCF_01.write8(B00000010); 
      break;

    case 2:   // 40 Meters
      frq = constrain(frq, 7000000, 7300000);
      frequency2 = frq;
      genfrequency=frq;
      PCF_01.write8(B00000100); 
      break;

    case 3:     // 30 Meters
      frq = constrain(frq, 10100000, 10150000);
      frequency3 = frq;
      genfrequency=(frq);
      PCF_01.write8(B00001000); 
      break;
   
    case 4:   // 20 Meters
      frq = constrain(frq, 14100000, 14350000);
      frequency4 = frq;
      genfrequency=frq;
      PCF_01.write8(B00010000); 
      break;

    case 5:   // full for debug
      frq = constrain(frq, 1500000, 14350000);
      frequency5 = frq;
      genfrequency=frq;
      PCF_01.write8(B00100000); 
      break;
  }
    updateFlag=LOW; 
}
// does the freq need to be updated?
         if(f_fchange==1)
         {  frequie.set_clock_frequency(0, (genfrequency + offset));   // 
            f_fchange=0;
         } 
         dsp_S_Meter();
}

/*-----------------------------------------------------------------------------------------------
        Alternative Loop (core0)
------------------------------------------------------------------------------------------------*/
void task0(void* arg)
{
     while (1)
     {    
         pcnt_get_counter_value(PCNT_UNIT_0, &RE_Count);          
         int count=RE_Count;
         pcnt_counter_clear(PCNT_UNIT_0);
         
         if(f_rev==1) count=-count;
                  
        
        if(count!=0){                           
          afstp=(long)(0.5 + (float)(count)*((float)step_size + Racc*L*L) );         
          if(abs(count)>=vth) L+=1.0*(float)( abs(count) - vth );
          if(L>MaxL) L=MaxL;                                  
        }else{         
          L-=Rdec;
          if(L<0) L=0;
        }
 


    //---Update frequency -------------------------------
        if(afstp!=0){
          frq+=afstp;

          afstp=0;
          f_dchange=1;
          f_fchange=1;                                                     
        }
        
/*        // moved to loop (core1)
         //-------------------------------------
         if(f_fchange==1){
            f_fchange=0;
  
         frequie.set_clock_frequency(0, (genfrequency + offset));   // 
         }        
         //-------------------------------------
*/

         if(f_redraw==1){
            Transfer_Image();
            f_redraw=0;
         }                  
         delay(1);
     }

    select_dspMode();

  while (dsp_Mode == _VU_MTR) {
    dsp_VU_Meter();
    select_dspMode();
  }
  while (dsp_Mode == _S_MTR) {
    dsp_S_Meter();
    select_dspMode();
  }
  while (dsp_Mode == _POWER) {
    dsp_PWR_Meter();
    select_dspMode();
  }

  while (dsp_Mode == _SWR) {
    dsp_SWR_Meter();
    select_dspMode();
  }
 
}

void set_band(int inc) {   
    unsigned long ham_band[] = { frequency0,frequency1,frequency2,frequency3,frequency4,frequency5,frequency6,frequency7,frequency8 };

  ham_band[ham_band_index]=frq;     // save the old setting
  ham_band_index = (ham_band_index+inc);
  ham_band_index = constrain(ham_band_index, 0, MaxBand); 

  frq = ham_band[ham_band_index];     // change frequency band
      f_fchange = 1;
      f_dchange = 1;   
}
